Index: main/waeup.ikoba/trunk/src/waeup/ikoba/app.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/app.py	(revision 12706)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/app.py	(revision 12741)
@@ -35,4 +35,5 @@
 from waeup.ikoba.products.container import ProductsContainer
 from waeup.ikoba.documents.container import DocumentsContainer
+from waeup.ikoba.payments.container import PaymentsContainer
 
 
@@ -59,5 +60,4 @@
         the like.
         """
-
         self['users'] = UsersContainer()
         self['datacenter'] = DataCenter()
@@ -67,4 +67,5 @@
         self['products'] = ProductsContainer()
         self['documents'] = DocumentsContainer()
+        self['payments'] = PaymentsContainer()
         self._createPlugins()
 
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/customers/browser.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/customers/browser.py	(revision 12706)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/customers/browser.py	(revision 12741)
@@ -18,17 +18,11 @@
 """UI components for customers and related components.
 """
-
-import sys
 import grok
-import pytz
 import os
 from urllib import urlencode
-from datetime import datetime
 from zope.event import notify
 from zope.i18n import translate
 from zope.catalog.interfaces import ICatalog
 from zope.component import queryUtility, getUtility, createObject
-from zope.schema.interfaces import ConstraintNotSatisfied, RequiredMissing
-from zope.formlib.textwidgets import BytesDisplayWidget
 from zope.security import checkPermission
 from hurry.workflow.interfaces import (
@@ -42,23 +36,25 @@
 from waeup.ikoba.browser.layout import (
     IkobaPage, IkobaEditFormPage, IkobaAddFormPage, IkobaDisplayFormPage,
-    IkobaForm, NullValidator, jsaction, action, UtilityView)
-from waeup.ikoba.widgets.datewidget import (
-    FriendlyDateWidget, FriendlyDateDisplayWidget,
-    FriendlyDatetimeDisplayWidget)
+    NullValidator, jsaction, action, UtilityView)
 from waeup.ikoba.browser.pages import ContactAdminForm
 from waeup.ikoba.browser.breadcrumbs import Breadcrumb
 from waeup.ikoba.browser.interfaces import ICaptchaManager
 from waeup.ikoba.mandates.mandate import PasswordMandate
+from waeup.ikoba.payments.payment import format_payment_item_values
+from waeup.ikoba.payments.interfaces import (
+    IPaymentGatewayServicesLister, IPaymentGatewayService, IPayer, IPayable
+    )
 from waeup.ikoba.widgets.hrefwidget import HREFDisplayWidget
 from waeup.ikoba.utils.helpers import (
-    get_current_principal, to_timezone, now, format_date)
+    get_current_principal, format_date)
 from waeup.ikoba.customers.interfaces import (
     ICustomer, ICustomersContainer, ICustomerRequestPW, ICustomersUtils,
     ICustomerDocument, ICustomerDocumentsContainer, ICustomerCreate,
     ICustomerPDFDocument, IContractsContainer, IContract,
-    IContractSelectProduct, ISampleContract,
+    IContractSelectProduct,
     )
 from waeup.ikoba.customers.catalog import search
 from waeup.ikoba.customers.workflow import PAYMENT_TRANSITIONS
+
 
 grok.context(IIkobaObject)
@@ -927,5 +923,4 @@
     def createDocument(self, **data):
         form = self.request.form
-        customer = self.context.__parent__
         doctype = form.get('doctype', None)
         # Here we can create various instances of CustomerDocument derived 
@@ -1098,5 +1093,4 @@
         tableheader = []
         tabledata = []
-        contenttitle = []
         for i in range(1,3):
             tabledata.append(sorted(
@@ -1134,5 +1128,4 @@
     @property
     def label(self):
-        portal_language = getUtility(IIkobaUtils).PORTAL_LANGUAGE
         return '%s of %s\nTitle: %s' % (
             self.context.translated_class_name,
@@ -1141,5 +1134,4 @@
 
     def render(self):
-        portal_language = getUtility(IIkobaUtils).PORTAL_LANGUAGE
         customerview = CustomerBasePDFFormPage(self.context.customer,
             self.request, self.omit_fields)
@@ -1157,5 +1149,4 @@
 
     def render(self):
-        portal_language = getUtility(IIkobaUtils).PORTAL_LANGUAGE
         customerview = CustomerBasePDFFormPage(self.context.customer,
             self.request, self.omit_fields)
@@ -1295,5 +1286,4 @@
     def createContract(self, **data):
         form = self.request.form
-        customer = self.context.__parent__
         contype = form.get('contype', None)
         # Here we can create various instances of Contract derived
@@ -1506,17 +1496,49 @@
     label = _('Select payment method')
 
-    def update(self, CANCEL=None):
+    @property
+    def payment_gateways(self):
+        """Get an iter over registered and enabled gateway service providers.
+
+        We provide tuples ``(value, description)`` for each supported
+        payment gateway.
+        """
+        lister = getUtility(IPaymentGatewayServicesLister)
+        for name, service in lister().items():
+            yield {'name': name, 'title': service.title}
+
+    def update(self, CANCEL=None, gw=None):
         if self.context.state != CREATED or not self.context.fee_based:
             emit_lock_message(self)
             return
+        self.gw = gw
         super(SelectPaymentMethodPage, self).update()
         return
 
-    @action(_('Select payment method and proceed to payment gateway (final submission)'),
-            style='primary', warning=WARNING_CON,)
+    @action(_('Select payment method (final submission)'),
+            style='primary')
     def confirm(self, **data):
-        IWorkflowInfo(self.context).fireTransition('await')
-        self.flash(_('Payment has been initiated.'))
-        return
+        if self.gw is None:
+            self.flash(_('Please pick a payment method.'),
+                       type='warning')
+        else:
+            service = queryUtility(IPaymentGatewayService, name=self.gw)
+            if service is None:
+                self.flash(_('Invalid payment gateway.'), type='danger')
+                return
+            payer = IPayer(self.context)
+            payable = IPayable(self.context)
+            payment = service.create_payment(payer, payable)
+            service.store(payment)
+            payment, view_name = service.next_step(payment.payment_id)
+            url = self.url(payment, view_name)
+            self.redirect(url)
+            return
+        return
+
+    @action(_('Cancel'))
+    def cancel(self, **data):
+        self.redirect(self.url(self.context, 'edit'))
+        return
+
 
 class ContractTriggerTransitionFormPage(IkobaEditFormPage):
@@ -1600,5 +1622,4 @@
         tableheader = []
         tabledata = []
-        contenttitle = []
         for i in range(1,3):
             tabledata.append(sorted(
@@ -1655,5 +1676,4 @@
     @property
     def label(self):
-        portal_language = getUtility(IIkobaUtils).PORTAL_LANGUAGE
         return self.context.title
 
@@ -1670,5 +1690,4 @@
 
     def render(self):
-        portal_language = getUtility(IIkobaUtils).PORTAL_LANGUAGE
         customerview = CustomerBasePDFFormPage(self.context.customer,
             self.request, self.omit_fields)
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/customers/browser_templates/selectpaymentmethodpage.pt
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/customers/browser_templates/selectpaymentmethodpage.pt	(revision 12706)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/customers/browser_templates/selectpaymentmethodpage.pt	(revision 12741)
@@ -1,20 +1,17 @@
+
 <form action="." tal:attributes="action request/URL" method="post"
       i18n:domain="waeup.ikoba" enctype="multipart/form-data">
 
-  <table class="form-table">
-    <tbody>
-      <tr>
-        <td class="fieldname" i18n:translate=""></td>
-        <td>
-        </td>
-      </tr>
-      <tr>
-        <td class="fieldname" i18n:translate=""></td>
-        <td>
+  <div class="form-group">
 
-        </td>
-      </tr>
-    </tbody>
-  </table>
+    <div class="radio" tal:repeat="service view/payment_gateways">
+      <label>
+        <input type="radio" name="gw" tal:attributes="value service/name" />
+        <b><span tal:replace="service/title" /></b>
+      </label>
+    </div>
+
+  </div>
+
   <br />
 
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/customers/contracts.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/customers/contracts.py	(revision 12706)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/customers/contracts.py	(revision 12741)
@@ -19,23 +19,27 @@
 Customer contract components.
 """
-import os
 import grok
-from zope.component import queryUtility, getUtility
+from hurry.workflow.interfaces import IWorkflowInfo, IWorkflowState
+from zope.catalog.interfaces import ICatalog
+from zope.component import getUtility, queryUtility
 from zope.component.interfaces import IFactory
 from zope.interface import implementedBy
 from zope.schema import getFields
-from hurry.workflow.interfaces import IWorkflowInfo, IWorkflowState
 from waeup.ikoba.interfaces import MessageFactory as _
 from waeup.ikoba.interfaces import (
-    IIkobaUtils, IObjectHistory,
-    VERIFIED, APPROVED, PROVISIONALLY,
-    IIDSource)
+    IObjectHistory, VERIFIED, APPROVED, PROVISIONALLY, IIDSource)
 from waeup.ikoba.customers.interfaces import (
-    IContractsContainer, ICustomerNavigation,
-    IContract, IContractSelectProduct, ICustomersUtils,
-    ISampleContract, ISampleContractProcess, ISampleContractEdit,
-    ISampleContractOfficialUse)
-from waeup.ikoba.customers.utils import generate_contract_id
+    IContractsContainer, ICustomerNavigation, IContract,
+    IContractSelectProduct, ICustomersUtils, ISampleContract,
+    ISampleContractProcess, ISampleContractEdit, ISampleContractOfficialUse)
+from waeup.ikoba.payments.interfaces import (
+    IPayer, IPayableFinder, IPayable, IPaymentWaitingForGatewayEvent,
+    STATE_PAID, STATE_FAILED, IPaymentFinishedEvent
+    )
+from waeup.ikoba.payments.payment import (
+    PaymentItem, find_payable_from_payable_id,
+    )
 from waeup.ikoba.utils.helpers import attrs_to_fields
+
 
 class ContractsContainer(grok.Container):
@@ -61,9 +65,36 @@
 ContractsContainer = attrs_to_fields(ContractsContainer)
 
+
+class ContractPayer(grok.Adapter):
+    """Adapter to turn contracts into IPayers.
+    """
+    grok.implements(IPayer)
+    grok.context(IContract)
+
+    def __init__(self, context):
+        self.context = context
+
+    @property
+    def _customer(self):
+        return self.context.customer
+
+    @property
+    def first_name(self):
+        return getattr(self._customer, 'firstname', None)
+
+    @property
+    def last_name(self):
+        return getattr(self._customer, 'lastname', None)
+
+    @property
+    def payer_id(self):
+        return getattr(self._customer, 'customer_id', None)
+
+
 class ContractBase(grok.Container):
     """This is a customer contract baseclass.
     """
-    grok.implements(IContractSelectProduct)  # Necesary for the selectproduct page
-
+    grok.implements(IContractSelectProduct)  # Neccessary for the
+                                             # selectproduct page (why?)
     grok.baseclass()
 
@@ -150,5 +181,6 @@
                 state = getattr(obj, 'state', None)
                 if state and state != VERIFIED:
-                    return False, _("Attached documents must be verified first.")
+                    return False, _(
+                        "Attached documents must be verified first.")
         return True, None
 
@@ -177,5 +209,5 @@
 
     grok.implements(
-        ISampleContractProcess, # must come before ISampleContract
+        ISampleContractProcess,  # must come before ISampleContract
         ISampleContract,
         ISampleContractEdit,
@@ -210,4 +242,5 @@
         return implementedBy(SampleContract)
 
+
 @grok.subscribe(IContract, grok.IObjectAddedEvent)
 def handle_contract_added(contract, event):
@@ -218,2 +251,80 @@
         IWorkflowInfo(contract).fireTransition('create')
     return
+
+
+@grok.subscribe(IPaymentWaitingForGatewayEvent)
+def handle_payment_waiting_for_gw(event):
+    maybe_contract = find_payable_from_payable_id(
+        event.object.payable_id)
+    if IContract.providedBy(maybe_contract):
+        IWorkflowInfo(maybe_contract).fireTransition('await')
+
+
+@grok.subscribe(IPaymentFinishedEvent)
+def handle_payment_finished(event):
+    payment = event.object
+    maybe_contract = find_payable_from_payable_id(payment.payable_id)
+    if not IContract.providedBy(maybe_contract):
+        return
+    if payment.state == STATE_PAID:
+        IWorkflowInfo(maybe_contract).fireTransition('confirm')
+    else:
+        IWorkflowInfo(maybe_contract).fireTransition('discard')
+
+
+class ContractFinder(grok.GlobalUtility):
+    grok.name('contracts_finder')
+    grok.implements(IPayableFinder)
+
+    def get_payable_by_id(self, contract_id):
+        catalog = queryUtility(ICatalog, 'contracts_catalog')
+        if catalog is None:
+            return None
+        result = catalog.searchResults(
+            contract_id=(contract_id, contract_id))
+        result = [x for x in result]
+        if not result:
+            return None
+        # there should not be more than one result really.
+        return result[0]
+
+
+class PayableContract(grok.Adapter):
+    """Adapter to adapt IContracts to IPayable.
+    """
+
+    grok.context(IContract)
+    grok.implements(IPayable)
+
+    def __init__(self, context):
+        self.context = context
+        currencies = set([x.currency for x in context.product_options])
+        if len(currencies) > 1:
+            raise ValueError(
+                "Only contracts with same currency for all options allowed.")
+        return
+
+    @property
+    def payable_id(self):
+        return self.context.contract_id
+
+    @property
+    def title(self):
+        return self.context.title or u''
+
+    @property
+    def currency(self):
+        if not len(self.context.product_options):
+            return None
+        return self.context.product_options[0].currency
+
+    @property
+    def payment_items(self):
+        result = []
+        for num, option in enumerate(self.context.product_options):
+            item = PaymentItem()
+            item.item_id = u'%s' % num
+            item.title = option.title
+            item.amount = option.fee
+            result.append(item)
+        return tuple(result)
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/customers/customer.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/customers/customer.py	(revision 12706)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/customers/customer.py	(revision 12741)
@@ -25,9 +25,9 @@
 from hurry.workflow.interfaces import IWorkflowState, IWorkflowInfo
 from zope.password.interfaces import IPasswordManager
-from zope.component import getUtility, createObject
+from zope.catalog.interfaces import ICatalog
+from zope.component import getUtility, queryUtility
 from zope.component.interfaces import IFactory
 from zope.interface import implementedBy
 from zope.securitypolicy.interfaces import IPrincipalRoleManager
-from zope.schema.interfaces import ConstraintNotSatisfied
 
 from waeup.ikoba.image import IkobaImageFile
@@ -35,6 +35,5 @@
 from waeup.ikoba.interfaces import (
     IObjectHistory, IUserAccount, IFileStoreNameChooser, IFileStoreHandler,
-    IIkobaUtils, IExtFileStore,
-    CREATED, REQUESTED, APPROVED)
+    IIkobaUtils, IExtFileStore, )
 from waeup.ikoba.customers.interfaces import (
     ICustomer, ICustomerNavigation, ICSVCustomerExporter,
@@ -43,5 +42,8 @@
 from waeup.ikoba.customers.documents import CustomerDocumentsContainer
 from waeup.ikoba.customers.contracts import ContractsContainer
-from waeup.ikoba.utils.helpers import attrs_to_fields, now, copy_filesystem_tree
+from waeup.ikoba.payments.interfaces import IPayer, IPayerFinder
+from waeup.ikoba.utils.helpers import (
+    attrs_to_fields, now, copy_filesystem_tree)
+
 
 class Customer(grok.Container):
@@ -77,5 +79,6 @@
             'password'] = passwordmanager.encodePassword(password)
         self.temp_password['user'] = user
-        self.temp_password['timestamp'] = datetime.utcnow()  # offset-naive datetime
+        self.temp_password[
+            'timestamp'] = datetime.utcnow()  # offset-naive datetime
 
     def getTempPassword(self):
@@ -89,6 +92,6 @@
         if temp_password_dict is not None:
             delta = timedelta(minutes=self.temp_password_minutes)
-            now = datetime.utcnow()
-            if now < temp_password_dict.get('timestamp') + delta:
+            dt_now = datetime.utcnow()
+            if dt_now < temp_password_dict.get('timestamp') + delta:
                 return temp_password_dict.get('password')
             else:
@@ -98,5 +101,6 @@
 
     def writeLogMessage(self, view, message):
-        ob_class = view.__implemented__.__name__.replace('waeup.ikoba.','')
+        ob_class = view.__implemented__.__name__.replace(
+            'waeup.ikoba.', '')
         self.__parent__.logger.info(
             '%s - %s - %s' % (ob_class, self.__name__, message))
@@ -196,4 +200,5 @@
     return
 
+
 def move_customer_files(customer, del_dir):
     """Move files belonging to `customer` to `del_dir`.
@@ -246,5 +251,5 @@
         timestamp = str(now().replace(microsecond=0))  # store UTC timestamp
         for num, row in enumerate(csv_data[1:-1]):
-            csv_data[num+1] = csv_data[num+1] + ',' + timestamp
+            csv_data[num + 1] = csv_data[num + 1] + ',' + timestamp
         csv_path = os.path.join(del_dir, '%s.csv' % name)
 
@@ -399,2 +404,40 @@
         return file, path, IkobaImageFile(
             file_obj.filename, file_obj.data)
+
+
+class CustomerPayer(grok.Adapter):
+    """Adapter to turn customers into IPayers.
+    """
+    grok.implements(IPayer)
+    grok.context(ICustomer)
+
+    @property
+    def first_name(self):
+        return getattr(self.context, 'firstname', None)
+
+    @property
+    def last_name(self):
+        return getattr(self.context, 'lastname', None)
+
+    @property
+    def payer_id(self):
+        return getattr(self.context, 'customer_id', None)
+
+
+class CustomerFinder(grok.GlobalUtility):
+    """Find customers.
+    """
+    grok.name('customer_finder')
+    grok.implements(IPayerFinder)
+
+    def get_payer_by_id(self, customer_id):
+        catalog = queryUtility(ICatalog, 'customers_catalog')
+        if catalog is None:
+            return None
+        result = catalog.searchResults(
+            customer_id=(customer_id, customer_id))
+        result = [x for x in result]
+        if not result:
+            return None
+        # there should not be more than one result really.
+        return result[0]
Index: main/waeup.ikoba/trunk/src/waeup/ikoba/customers/export.py
===================================================================
--- main/waeup.ikoba/trunk/src/waeup/ikoba/customers/export.py	(revision 12706)
+++ main/waeup.ikoba/trunk/src/waeup/ikoba/customers/export.py	(revision 12741)
@@ -215,5 +215,6 @@
                       'translated_class_name',
                       'is_editable',
-                      'is_approvable'])))
+                      'is_approvable',
+                      'customer'])))
 
     def filter_func(self, x, **kw):
